*----------------------------------------------------------*
*          TableCurve 3D FORTRAN 77 Code Output
*       To modify generated output, edit FORT77.TCL
*----------------------------------------------------------*

*----------------------------------------------------------*
      PROGRAM main
*----------------------------------------------------------*
      DOUBLE PRECISION x,y,z

   10 PRINT *,'Enter X: '
      READ *,x
      PRINT *,'Enter Y: '
      READ *,y
      IF(x.EQ.0 .AND. y.EQ.0) GOTO 20
      CALL eqn405(x,y,z)
      PRINT *,'Z=',z
      GOTO 10
   20 END

*----------------------------------------------------------*
      SUBROUTINE EVALCPOLY(order, logx, logy, x, y, c, z)
*----------------------------------------------------------*
      INTEGER order,logx,logy
      DOUBLE PRECISION x,y,c(*),z
      INTEGER tcnt,j,m,iv
      DOUBLE PRECISION tx(12),ty(12),v(70)
      IF(logx.NE.1) THEN
        x=(x-(42.50000000000000D0))/(22.50000000000000D0)
      ELSE
        x=(DLOG(x)-(3.585059771724814D0))/(0.5893274981708231D0)
      END IF
      IF(logy.NE.1) THEN
        y=(y-(42.50000000000000D0))/(107.5000000000000D0)
      ELSE
        y=(DLOG(y)-(0.000000000000000D0))/(0.000000000000000D0)
      END IF
      IF(order.EQ.5) THEN
        tcnt=3
      ELSE IF (order.EQ.9) THEN
        tcnt=4
      ELSE IF (order.EQ.14) THEN
        tcnt=5
      ELSE IF (order.EQ.20) THEN
        tcnt=6
      ELSE IF (order.EQ.27) THEN
        tcnt=7
      ELSE IF (order.EQ.35) THEN
        tcnt=8
      ELSE IF (order.EQ.44) THEN
        tcnt=9
      ELSE IF (order.EQ.54) THEN
        tcnt=10
      ELSE IF (order.EQ.65) THEN
        tcnt=11
      ELSE
        z=0.0
        RETURN
      END IF
      IF(tcnt.GT.6) THEN
        IF(x.LT.-1.D0) x=-1.D0
        IF(x.GT. 1.D0) x= 1.D0
        IF(y.LT.-1.D0) y=-1.D0
        IF(y.GT. 1.D0) y= 1.D0
      END IF
      tx(1)=1.D0
      ty(1)=1.D0
      tx(2)=x
      ty(2)=y
      DO 10 j=3,tcnt
        tx(j)=2*x*tx(j-1)-tx(j-2)
        ty(j)=2*y*ty(j-1)-ty(j-2)
   10 CONTINUE
      iv=1
      DO 30 j=1,tcnt
        DO 20 m=j,1,-1
          v(iv)=tx(m)*ty(j-m+1)
          iv=iv+1
   20   CONTINUE
   30 CONTINUE
      z=0.0
      DO 40, j=1,order+1
        z = z + c(j)*v(j)
   40 CONTINUE
      RETURN
      END

*----------------------------------------------------------*
      SUBROUTINE eqn405(x,y,z)
*----------------------------------------------------------*
* TableCurve 3D
* File Source= p:\daten\tablecurv\an neue rezeptur (oat)\annkub koeff oat.prn
* Date= Jun 18, 2012
* Time= 2:28:06 PM
* Data Source= P:\DATEN\TABLECURV\AN neue Rezeptur (OAT)\kub Koeff.xls
* X= 
* Y= 
* Z= 
* Eqn#= 405
* Eqn= Chebyshev X,Y Bivariate Polynomial Order 6
* r2=0.9999966023381861
* r2adj=0.9999957295443257
* StdErr=3.595569229246354E-07
* Fstat=1199077.617169058
* a= 0.0005362996507738688
* b= 9.155759252681491E-05
* c= 0.00036869594207612
* d= -1.097336017407472E-05
* e= -9.752541189722928E-05
* f= -4.435091590866245E-05
* g= -1.592101329101424E-06
* h= 1.096938894868135E-05
* i= 2.105311089285031E-05
* j= 9.400974727350829E-09
* k= 1.337599405981331E-06
* l= 2.100436402636114E-06
* m= -2.384641315593932E-06
* n= -2.205561787334095E-07
* o= -5.536746136567192E-07
* p= -1.474943108931354E-06
* q= -1.963434453093814E-06
* r= -1.907344817247346E-07
* s= 3.254511160139666E-07
* t= 7.91914796574521E-07
* u= 3.532458439057282E-07
* v= 1.727740960887166E-07
* aa= 1.907689748167663E-06
* ab= -6.871852321573539E-08
* ac= -2.024977329989997E-07
* ad= -2.098722212824788E-07
* ae= -4.611488382274493E-07
* af= 1.464142010869392E-07
*----------------------------------------------------------*
      DOUBLE PRECISION x,y,z
      DOUBLE PRECISION c(27+1)
      DATA c(1)/0.0005362996507738688D0/
      DATA c(2)/9.155759252681491D-05/
      DATA c(3)/0.0003686959420761200D0/
      DATA c(4)/-1.097336017407472D-05/
      DATA c(5)/-9.752541189722928D-05/
      DATA c(6)/-4.435091590866245D-05/
      DATA c(7)/-1.592101329101424D-06/
      DATA c(8)/1.096938894868135D-05/
      DATA c(9)/2.105311089285031D-05/
      DATA c(10)/9.400974727350829D-09/
      DATA c(11)/1.337599405981331D-06/
      DATA c(12)/2.100436402636114D-06/
      DATA c(13)/-2.384641315593932D-06/
      DATA c(14)/-2.205561787334095D-07/
      DATA c(15)/-5.536746136567192D-07/
      DATA c(16)/-1.474943108931354D-06/
      DATA c(17)/-1.963434453093814D-06/
      DATA c(18)/-1.907344817247346D-07/
      DATA c(19)/3.254511160139666D-07/
      DATA c(20)/7.919147965745210D-07/
      DATA c(21)/3.532458439057282D-07/
      DATA c(22)/1.727740960887166D-07/
      DATA c(23)/1.907689748167663D-06/
      DATA c(24)/-6.871852321573539D-08/
      DATA c(25)/-2.024977329989997D-07/
      DATA c(26)/-2.098722212824788D-07/
      DATA c(27)/-4.611488382274493D-07/
      DATA c(28)/1.464142010869392D-07/
      CALL EVALCPOLY(27,0,0,x,y,c,z)
      RETURN
      END
